class Editor.EditorModule.DockModule.ScenarioBay.Elements extends Pettanr.View
  tagName: 'ul'
  className: 'scenarios_elements'
  
  initialize: (options) ->
    super(options)
    @parent = options.parent
    @element_lis = []
  
  render: () ->
    this.$el.html('')
    _.each @scenario_elements(), (element_li) =>
      this.$el.append(element_li.render().$el)
    _this = this
    this.$el.sortable {
      update: (event, ui) ->
        _this.reorder()
        _this.trigger('sorted')
    }
    this
  
  refresh: () ->
    _.each @element_lis, (element_li) =>
      element_li.refresh()
  
  scenario_elements: () ->
    res = []
    _.each @element_lis, (element_li) =>
      res[element_li.t()] = element_li
    res
  
  add_element: (element) ->
    e = new Editor.EditorModule.DockModule.ScenarioBay.Element({
      parent: this, 
      element: element
    })
    @element_lis.push(e) # insert array
    @render()
    e
  
  find_li: (element) ->
    li = null
    _.each @element_lis, (element_li) =>
      if element_li.element.cid == element.cid
        li = element_li
        return
    li
  
  remove_element: (element) ->
    element_li = @find_li(element)
    i = @element_lis.indexOf(element_li)
    @element_lis[i].remove()
    @element_lis.splice(i, 1)
    @unshift_z()
  
  unshift_z: () ->
    @reorder()
  
  reorder: () ->
    t = 0
    $('.t-label', this.$el).map ->
      $(@).attr('data-t', t)
      t++
  
  sorted: () ->
    # data-t copy to model
    @trigger('sorted')
  
