class Editor.Player.PanelMoveDialog extends Editor.Dialog
  className: 'player-move-dialog'
  
  initialize: (options) ->
    super(options)
    @parent = options.parent
    @binder = options.binder
    @target_model = options.target_model
    @from = options.from
    @caught = true
  
  start: (panel) ->
    this.$el.dialog({title: I18n.t('scroll_panels.player.move_dialog')})
    body = new Pettanr.Views.Panel.Body({
      panel: panel,
      spot: null
    })
    @refresh(body.render())
    _this = this
    this.$el.dialog({
      autoOpen: false,
      width: 500, 
      height: 500,
      close: (ui, event) ->
        _this.close()
    })
    this.$el.dialog('open')
  
  stop: () ->
    this.$el.dialog('close')
  
  save: (insert_point) ->
    @to = insert_point
    t = insert_point.scroll_panel.get('t')
    item = @from.scroll_panel
    item.set({t: t}, {silent: true})
    @listenTo(item, 'save:success', @success)
    @listenTo(item, 'save:fail', @fail)
    item.save()
  
  success: (model, response) ->
    @from.scroll_panel.fix()
    @trigger('success', model, response)
  
  fail: (model, response) ->
    @trigger('fail', response)
  
  close: () ->
    @trigger('close')
  
  quit: () ->
    @remove()
  
  release: () ->
    @caught = false
  
  is_catch: () ->
    @caught
  
