class Pettanr.Folder extends Peta.Owner
  
  @singular: () ->
    'Folder'
  
  @plural: () ->
    'Folders'
  
  defaults: {
    id: null,
    name: 'no name'
  } 
  
  caption: () ->
    @get('name').replace(/\/$/, '').split('/').pop()
  
  filer_caption: (context, options) ->
    caption = _.escape(@caption())
    options.success.call(context, caption)
  
  is_remote: () ->
    if @get('category_id') == 10
      true
    else
      false
  
  remote_name: () ->
    Pettanr.to_s(@get('controller_name')) + '/' + Pettanr.to_s(@get('action_name'))
  
  remote_url: () ->
    c = @get('controller_name')
    a = if Pettanr.is_blank(@get('action_name'))
      'index'
    else
      @get('action_name')
    c + '/' + a
  
  event_name: () ->
    a = if Pettanr.is_blank(@get('action_name'))
      'index'
    else
      @get('action_name')
    Pettanr.to_s(@get('controller_name')) + '_' + a
  
  initialize: (attr = {}, options = {}) ->
    super(attr, options)
  
class Pettanr.FolderWatch extends Pettanr.Folder
  
  initialize: (attr = {}, options = {}) ->
    super(attr, options)
    @url = @default_url() + '?ref=1'
  
class Pettanr.Folder.Root extends Pettanr.Folder
  model: Pettanr.Folder
  
  initialize: (attr = {}, options = {}) ->
    super(attr, options)
    @url = @default_url() + 'root?ref=1'
  
class Pettanr.Folder.Children extends Backbone.Collection
  model: Pettanr.Folder
  
  initialize: (options) ->
    @url = '/folders/' + options.id.toString()
  
