class DemandUser < ActiveRecord::Base
  has_one :demander
  
  # Include default devise modules. Others available are:
  # :encryptable, :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable 
  
  def create_token
    self.ensure_authentication_token
    self.save
  end
  
  def delete_token
    self.authentication_token = nil
    self.save
  end
  
  private
  def demand_user_params
    params.require(:demand_user).permit(:email, :password, :password_confirmation, :remember_me, :authentication_token)
  end
  
end
