
module Locmare
  class Bucket
    attr :manifest, :bucket_name, :use_name, :item, :mounted, :submit, :operators, :template_dir, 
      :fields
    
    def self.factory bucket_or_form_name, use_name, item, mounted, submit, operators
      bucket = LocalManifest.manifest.buckets[bucket_or_form_name]
      c = if bucket and bucket.has_member?
        Locmare::Bucket
      else
        Locmare::Form
      end
      c.new bucket_or_form_name, use_name, item, mounted, submit, operators
    end
    
    def initialize bucket_name, use_name, item, mounted, submit, operators
      @bucket_name = bucket_name
      @use_name = use_name
      @item = item
      @mounted = mounted
      @submit = submit
      @operators = operators
      
      @item.boosts 'post'
      @manifest = LocalManifest.manifest.buckets[@bucket_name]
      @template_dir = 'templates/r/form/'
      @form_fields = []
      @forms = {}
      @forms[@item.item_name] = Locmare::Form.new @item.item_name, @use_name, @item, @mounted, false, @operators
      self.init_forms @item.item_name, @manifest, @item
      self.init_fields
    end
    
    def fold_extend_settings params
      @item.class.fold_extend_settings params[@item.item_name]
      self.members_fold_extend_settings @item, params[@item.item_name], @manifest
    end
    
    def members_fold_extend_settings fold_item, attr, man
      man.members.each do |member_name, member_manifest|
        member_item = fold_item.__send__ member_name
        member_item.class.fold_extend_settings attr[member_name + '_attributes']
        self.members_fold_extend_settings member_item, attr[member_name + '_attributes'], member_manifest
      end
    end
    
    def each_field
      @form_fields.each do |form_field|
        yield form_field.field_name, form_field
      end
    end
    
    def push_form key, form_name, item
    end
    
    def init_forms key, man, item
      man.members.each do |member_name, member_manifest|
        form_name = member_name   # write exchange function if you want
        member_item = item.__send__(form_name)
        new_key = key + '.' + form_name
        @forms[new_key] = Locmare::Form.new new_key, member_item, @mounted, false, @operators
        self.init_forms new_key, member_manifest, member_item
      end
    end
    
    def init_fields
      @manifest.form_field_names.each do |form_field_name|
        r = form_field_name.form_name.blank? ? '' : '.' + form_field_name.form_name
        key = @item.item_name + r
        form = @forms[key]
        field = form.fields[form_field_name.field_name]
        @form_fields << field
      end
    end
    
    def template_file_name
      "form"
    end
    
    def template_name
      self.template_dir + self.template_file_name
    end
    
    def fields_template_name
      self.template_dir + 'fields'
    end
    
    def image_dir
      '/images/'
    end
    
    def submit_name
      if @item.new_record?
        @item.table_name + '.submit.new'
      else
        @item.table_name + '.submit.edit'
      end
    end
    
    def submit_template_dir
      self.template_dir + 'submit/'
    end
    
    def submit_template_name
      if @submit
        self.submit_template_dir + 'submit'
      else
        self.submit_template_dir + 'none'
      end
    end
    
    def form_name
      @bucket_name
    end
    
  end
  
end

